//M/M/1 Queueing System,Average Arrival rate lambd=20customers per hour and avg. service time=1/u=2minutes.

a=20;                                                //Arrival rate(customers/hour)

b=30;                                                //Departure Rate(1/b=avg.service time)

N=25;                                                //Number of arrivals in simulation

x=-log(rand(1,N))/a;                                 //Random interarrival time

x=cumsum(x);                                         //Random arrival time

y=-log(rand(1,N))/b;                                 //Service times for each customer

ser_start=x(1);                                      //First customer starts service 
                                                     //immediately upon arrival.

z(1)=ser_start+y(1);                                 //Departure time of first customer

for k=2:N                                            //kth customer
    ser_start=max([z(k-1),x(k)]);                    //beginning of service time
    z(k)=ser_start+y(k);                             //end of service time.
end

//Construct date to plot graph of queue size vs. time.

xaxis=[0, x(1)];                                     //Vector of points for the M/M/1

yaxis=[0, 0];                                        //Vector of queue sizes at points in preceding vector.

qs=1;                                                //Current queue size.

x=x(2:length(x));

while length(x)>0
    if x(1)<z(1)                                     //Next point is arrival.
        qs=qs+1;                                     //Increase queue size
        xaxis=[xaxis xaxis(length(xaxis)) x(1)];
        yaxis=[yaxis qs qs];
        x=x(2:length(x));
    else                                             //Next point is departure.
        qs=qs-1;                                     //Decrease queue size
        xaxis=[xaxis xaxis(length(xaxis)) z(1)];
        yaxis=[yaxis qs qs];
        z=z(2:length(z));
    end
end

plot(xaxis,yaxis)                                    //Plot realization of birth-death process.

xlabel('time(hours)',fontsize',4);

ylabel('queue size','fontsize',4)